#include "crash82.inc"		;Assembly
.DB "SnAkEs 02! Phil Software",0;Title

PX = TEXT_MEM+1			;byte
PY = TEXT_MEM+2			;byte
DR = TEXT_MEM+3			;byte
SC = TEXT_MEM+4			;word
TPX = TEXT_MEM+6		;byte
TPY = TEXT_MEM+7		;byte
TDR = TEXT_MEM+8		;byte
SPD = TEXT_MEM+9		;byte


 ld	a,$8c			;Enable
 out	(2),a			;pixel plotting

 ld a,49			;store memory variables
 ld (PX),a			;
 ld a,32			;
 ld (PY),a			;
 ld a,6				;
 ld (DR),a			;
 ld hl,0			;
 ld (SC),hl			;
 ld a,47			;
 ld (TPX),a			;
 ld a,32			;
 ld (TPY),a			;
 ld a,4				;
 ld (TDR),a			;
 ld a,1				;
 ld (SPD),a			;

 ROM_CALL(CLEARLCD)		;ClrHome
 LD HL,0			;Point to
 LD (CURSOR_POS),HL		;1,1
 LD HL,Msg			;Load the String
 ROM_CALL(D_ZT_STR)		;Display it
 LD HL,$0001
 LD (CURSOR_POS),HL
 LD HL,HighScoreText
 ROM_CALL(D_ZT_STR)
 LD HL,$0A01
 LD (CURSOR_POS),HL
 LD HL,(HighScore)
 ROM_CALL(D_HL_DECI)
 LD HL,$0003
 LD (CURSOR_POS),HL
 LD HL,Speed2
 ROM_CALL(D_ZT_STR)
 LD HL,$0004
 LD (CURSOR_POS),HL
 LD HL,Speed3
 ROM_CALL(D_ZT_STR)
 LD HL,$0005
 LD (CURSOR_POS),HL
 LD HL,Speed4
 ROM_CALL(D_ZT_STR)






Pause:				;Loop Label
 CALL GET_KEY			;getKey->K
 CP G_1				;if it is 1, 2, or 3
 JR Z,Pick1			;then it will make that its speed
 CP G_2				;
 JR Z,Pick2			;
 CP G_3				;
 JR Z,Pick3			;
 CP G_4				;
 JR Z,Pick4			;
 JR Pause			;
Pick1:
 ld a,15
 ld (SPD),a
 JR Thingy1
Pick2:
 ld a,10
 ld (SPD),a
 JR Thingy1
Pick3:
 ld a,5
 ld (SPD),a
 JR Thingy1
Pick4:
 ld a,1
 ld (SPD),a
Thingy1:			;label
 ROM_CALL(CLEARLCD)		;clear
 call Clear_GRAPH_MEM		;Routine to clear Graph Mem
 JR Loop2			;Goto 
Loop2:				;label
 ld a,(PX)			;a=x
 inc a				;a++
 dec a				;a--
 CP 1				;If it is about to go off the screen...
 JP Z,Dead			;Goto DEAD
 CP 94				;If it is about to go off the screen...
 JP Z,Dead			;Goto DEAD
 ld a,(PY)			;a=y
 inc a				;a++
 dec a				;a--
 CP 1				;If it is about ot go off the screen...
 JP Z,Dead			;Goto DEAD
 CP 62				;If it is about to go off the screen...
 JP Z,Dead			;Goto DEAD

				;now for player two...

 ld a,(TPX)			;a=tx
 inc a				;a++
 dec a				;a--
 CP 1				;If it is about to go off the screen...
 JP Z,Dead2			;Goto DEAD2
 CP 94				;If it is about to go off the screen...
 JP Z,Dead2			;Goto DEAD2
 ld a,(TPY)			;a=ty
 inc a				;a++
 dec a				;a--
 CP 1				;If it is about ot go off the screen...
 JP Z,Dead2			;Goto DEAD2
 CP 62				;If it is about to go off the screen...
 JP Z,Dead2			;Goto DEAD2

				;control part of loop

 CALL GET_KEY			;call getkey
 CP G_UP			;\
 call z,Gup			; |
 CP G_LEFT			; |
 call z,Gleft			; |
 CP G_RIGTH			; |--- Control for player one
 call z,Gright			; |
 CP G_DOWN			; |
 call z,Gdown			;/

 CP G_CLEAR			;if it is clear
 RET Z				;end

 CP G_8				;\
 call z,G8			; |
 CP G_4				; |
 call z,G4			; |
 CP G_6				; |--- Control for player two
 call z,G6			; |
 CP G_2				; |
 call z,G2			;/

 CP $36				;if it is 2nd///////////////////////////////////////////////////////////////
 JP z,pauseG			;pause game

UnPause:

 ld a,(PX)			;a=x   \
 ld b,a				;b=a    |
 ld a,(PY)			;a=y    |_____ There has GOT to be some
 ld c,a				;c=a    |      easier way to do that!
 ld a,(DR)			;a=dir  |
 ld d,a				;d=a   /
 inc d				;d++
 dec d				;d--
 CP 2				;\
 JP Z,St2			; |
 CP 4				; |go the directions for player one
 JR Z,St4			; |
 CP 6				; |go the directions for player one
 JR Z,St6			; |
 CP 8				; |go the directions for player one
 JR Z,St8			; |
St2:				; |go the directions for player one
 dec c				; |
 JR St				; |go the directions for player one
St4:				; |
 ld a,b				; |go the directions for player one
 dec a				; |
 ld b,a				; |go the directions for player one
 JR St				; |
St6:				; |go the directions for player one
 inc b				; |
 JR St				; |go the directions for player one
St8:				; |
 inc c				; |go the directions for player one
St:				;/
 ld a,d
 ld (DR),a			;put back the direction in its var

 ld a,b
 ld (PX),a			;put back the places with the vars
 ld a,c
 ld (PY),a			;
 ld hl,(SC)			;make hl hold the score
 inc hl				;add one
 ld (SC),hl			;put it back

 call TestPixel			;test to see if where your guy is safe or not.
 JR NZ,Dead			;If it is unsafe, then it will end
 
 ld a,(PX)			;get ready
 ld b,a
 ld a,(PY)			;to put player one's pixel down
 ld c,a

 call PutPixel			;if not dead, put a pixel there




				;Now for player two...
				;Now for player two...
				;Now for player two...
				;Now for player two...
				;Now for player two...
				;Now for player two...
				;Now for player two...
				;Now for player two...
				;Now for player two...
				;Now for player two...
				;Now for player two...
				;Now for player two...
				;Now for player two...
				;Now for player two...
				;Now for player two...
				;Now for player two...


 ld a,(TPX)			;a=tx   \
 ld b,a				;b=a     |
 ld a,(TPY)			;a=ty    |_____ There has GOT to be some
 ld c,a				;c=a     |      easier way to do that!
 ld a,(TDR)			;a=tdir  |
 ld d,a				;d=a    /
 inc d				;d++
 dec d				;d--
 CP 2				;\
 JR Z,St22			; |
 CP 4				; |go the directions for player two
 JR Z,St42			; |
 CP 6				; |go the directions for player two
 JR Z,St62			; |
 CP 8				; |go the directions for player two
 JR Z,St82			; |
St22:				; |go the directions for player two
 dec c				; |
 JR Stb				; |go the directions for player two
St42:				; |
 ld a,b				; |go the directions for player two
 dec a				; |
 ld b,a				; |go the directions for player two
 JR Stb				; |
St62:				; |go the directions for player two
 inc b				; |
 JR Stb				; |go the directions for player two
St82:				; |
 inc c				; |go the directions for player two
Stb:				;/
 ld a,d
 ld (TDR),a			;put back the direction in its var

 ld a,b
 ld (TPX),a			;put back the places with the vars
 ld a,c
 ld (TPY),a			;


 call TestPixel			;test to see if where your guy is safe or not.
 JR NZ,Dead2			;If it is unsafe, then it will end
 
 ld a,(TPX)			;get ready
 ld b,a
 ld a,(TPY)			;to put player two's pixel down
 ld c,a

 call PutPixel			;if not dead, put a pixel there










 ROM_CALL(DISP_GRAPH)

 call Delay

 JP Loop2			;Loop again. LOL!
Dead:				;Here is where you DIE!
 ROM_CALL(CLEARLCD)		;ClrHome
 LD HL,0			;Point to
 LD (CURSOR_POS),HL		;1,1
 LD HL,Lose			;Load the String
 ROM_CALL(D_ZT_STR)		;Display it

 LD HL,$0001
 LD (CURSOR_POS),HL
 LD HL,Score			;Take out this line at it looks SWEET!
 ROM_CALL(D_ZT_STR)
 LD HL,$0601
 LD (CURSOR_POS),HL
 LD HL,(SC)
 ROM_CALL(D_HL_DECI)

 LD HL,(HighScore)
 LD DE,(SC)
 call CP_HL_DE
 jr nc,PPP
 LD HL,HighScore
 LD (HL),e
 inc HL
 LD (HL),d
 jr PPP


Dead2:
 ROM_CALL(CLEARLCD)		;ClrHome
 LD HL,0			;Point to
 LD (CURSOR_POS),HL		;1,1
 LD HL,Lose2			;Load the String
 ROM_CALL(D_ZT_STR)		;Display it

 LD HL,$0001
 LD (CURSOR_POS),HL
 LD HL,Score			;Take out this line at it looks SWEET!
 ROM_CALL(D_ZT_STR)
 LD HL,$0601
 LD (CURSOR_POS),HL
 LD HL,(SC)
 ROM_CALL(D_HL_DECI)

 LD HL,(HighScore)
 LD DE,(SC)
 call CP_HL_DE
 jr nc,PPP
 LD HL,HighScore
 LD (HL),e
 inc HL
 LD (HL),d


PPP:				;Loop Label
 CALL GET_KEY			;getKey->K
 CP G_ENTER			;Compare it to K
 JR NZ,PPP			;If not K=G_ENTER, loop
 ret				;otherwise... return END!!!


Clear_GRAPH_MEM:		; routine that clears
 ld     hl,GRAPH_MEM		; the GRAPH_MEM (fills
 ld     de,GRAPH_MEM+1		; it with zeros)
 ld     (hl),0			;
 ld     bc,767			;
 ldir				;
 ret				;

TestPixel:			;Tests the pixel at B,C. If the Z flag is set, no pixel, else a pixel is lit
 CALL FIND_PIXEL		;
 ld de,GRAPH_MEM		;
 add hl,de			;
 and (hl)			;
 ret				;

PutPixel:			; Puts a pixel at B,C
 CALL FIND_PIXEL		;
 ld de,GRAPH_MEM		;
 add hl,de			;
 or (hl)			;
 ld (hl),a			;
 ret				;

Gright:
 ld a,6
 ld (DR),a
 ret
Gleft:
 ld a,4
 ld (DR),a
 ret
Gup:
 ld a,8
 ld (DR),a
 ret
Gdown:
 ld a,2
 ld (DR),a
 ret


G6:
 ld a,6
 ld (TDR),a
 ret
G4:
 ld a,4
 ld (TDR),a
 ret
G8:
 ld a,8
 ld (TDR),a
 ret
G2:
 ld a,2
 ld (TDR),a
 ret

pauseG:
 call GET_KEY
 cp $36
 jP z,UnPause
 cp G_CLEAR
 ret z
 jr pauseG

Delay:
 LD a,(SPD)
 LD b,a				;routine displayed at karma.ticalc.org alterded a LOT by Me
Delay_Loop:
 HALT
 DJNZ Delay_Loop
 ret



Msg:				;String
.DB "Phil Software",0		;Stores

Lose:				;Other label storing
.db "Player one died.",0	;you lose

Lose2:
.db "Player two died.",0

Score:
.db "Score:",0

HighScore:
.ds 3

Speed2:
.db "Push 1, 2, 3, 4",0

Speed3:
.db "To choose speed.",0

Speed4:
.db "1=slow 4=fast",0

HighScoreText:
.db "HighScore:",0

.END				;Blah